diff -ruN versions/nakedmudv3.6/src/Makefile src/Makefile
--- versions/nakedmudv3.6/src/Makefile	2008-05-31 00:25:38.000000000 -0400
+++ src/Makefile	2008-11-16 06:38:14.000000000 -0500
@@ -103,6 +103,7 @@
 clean:
 	@rm -f $(BINARY)
 	@rm -f *.o $(patsubst %,%/*.o, $(MODULES))
+	@rm -f *.d $(patsubst %,%/*.d, $(MODULES))
 	@rm -f *~ $(patsubst %,%/*~, $(MODULES))
 	@rm -f ../lib/pymodules/*~
 	@rm -f ../lib/pymodules/*.pyc
diff -ruN versions/nakedmudv3.6/src/buffer.c src/buffer.c
--- versions/nakedmudv3.6/src/buffer.c	2008-05-31 00:17:59.000000000 -0400
+++ src/buffer.c	2008-12-03 00:42:47.000000000 -0500
@@ -207,6 +207,20 @@
     return 0;
 }
 
+void bufferFormatPy(BUFFER *buf) {
+  bufferReplace(buf, "\\", "\\\\", TRUE);
+  bufferReplace(buf, "\n", "\\n",  TRUE);
+  bufferReplace(buf, "\r", "\\r",  TRUE);
+  bufferReplace(buf, "\"", "\\\"", TRUE);
+}
+
+void bufferFormatFromPy(BUFFER *buf) {
+  bufferReplace(buf, "\\\\", "\\", TRUE);
+  bufferReplace(buf, "\\n",  "\n", TRUE);
+  bufferReplace(buf, "\\r",  "\r", TRUE);
+  bufferReplace(buf, "\\\"", "\"", TRUE);
+}
+
 void bufferFormat(BUFFER *buf, int max_width, int indent) {
   char formatted[(buf->len * 3)/2];
   bool needs_capital = TRUE, needs_indent = FALSE;
diff -ruN versions/nakedmudv3.6/src/buffer.h src/buffer.h
--- versions/nakedmudv3.6/src/buffer.h	2008-05-31 00:17:59.000000000 -0400
+++ src/buffer.h	2008-12-03 00:32:37.000000000 -0500
@@ -55,4 +55,10 @@
 // format a string with the given arguments
 void bufferFormat(BUFFER *buf, int max_width, int indent);
 
+// format our buffer to be a viable Python string
+void bufferFormatPy(BUFFER *buf);
+
+// format our buffer to be a C string from a Python string
+void bufferFormatFromPy(BUFFER *buf);
+
 #endif // BUFFER_H
diff -ruN versions/nakedmudv3.6/src/command.c src/command.c
--- versions/nakedmudv3.6/src/command.c	2008-05-31 00:17:59.000000000 -0400
+++ src/command.c	2008-12-01 22:20:44.000000000 -0500
@@ -247,14 +247,8 @@
 					  cmd->name);
 	PyObject *retval  = PyEval_CallObject(chk->pyfunc, arglist);
 	// check for an error:
-	if(retval == NULL) {
-	  char *tb = getPythonTraceback();
-	  if(tb != NULL) {
-	    log_string("Error running python command check, %s:\r\n%s\r\n", 
-		       cmd->name, tb);
-	    free(tb);
-	  }
-	}
+	if(retval == NULL)
+	  log_pyerr("Error running Python command check, %s:", cmd->name);
 	else if(retval == Py_False)
 	  cmd_ok = FALSE;
 
@@ -294,14 +288,8 @@
 					cmd->name, arg);
       PyObject *retval  = PyEval_CallObject(cmd->pyfunc, arglist);
       // check for an error:
-      if(retval == NULL) {
-	char *tb = getPythonTraceback();
-	if(tb != NULL) {
-	  log_string("Error running python command, %s:\r\n%s\r\n", 
-		     cmd->name, tb);
-	  free(tb);
-	}
-      }
+      if(retval == NULL)
+	log_pyerr("Error running Python command, %s:", cmd->name);
 
       // garbage collection
       Py_XDECREF(retval);
diff -ruN versions/nakedmudv3.6/src/commands.h src/commands.h
--- versions/nakedmudv3.6/src/commands.h	2008-05-31 00:17:59.000000000 -0400
+++ src/commands.h	2008-11-15 16:44:11.000000000 -0500
@@ -1,5 +1,5 @@
-#ifndef __COMMAND_H
-#define __COMMAND_H
+#ifndef __COMMANDS_H
+#define __COMMANDS_H
 //*****************************************************************************
 //
 // commands.h
@@ -16,4 +16,4 @@
 COMMAND(cmd_more);
 COMMAND(cmd_back);
 
-#endif // __COMMAND_H
+#endif // __COMMANDS_H
diff -ruN versions/nakedmudv3.6/src/handler.c src/handler.c
--- versions/nakedmudv3.6/src/handler.c	2008-05-31 00:17:59.000000000 -0400
+++ src/handler.c	2008-12-03 15:17:00.000000000 -0500
@@ -41,6 +41,10 @@
   propertyTablePut(exit_table, exit);
 }
 
+void exit_unexist(EXIT_DATA *exit) {
+  propertyTableRemove(exit_table, exitGetUID(exit));
+}
+
 bool exit_exists(EXIT_DATA *exit) {
   return propertyTableIn(exit_table, exitGetUID(exit));
 }
@@ -63,6 +67,19 @@
   }
 }
 
+void obj_unexist(OBJ_DATA *obj) {
+  // also unexist all contents
+  if(listSize(objGetContents(obj)) > 0) {
+    LIST_ITERATOR *cont_i = newListIterator(objGetContents(obj));
+    OBJ_DATA *cont = NULL;
+    ITERATE_LIST(cont, cont_i)
+      obj_unexist(cont);
+    deleteListIterator(cont_i);
+  }
+
+  propertyTableRemove(obj_table, objGetUID(obj));
+}
+
 bool obj_exists(OBJ_DATA *obj) {
   return propertyTableIn(obj_table, objGetUID(obj));
 }
@@ -116,6 +133,37 @@
   deleteListWith(ex_list, free);
 }
 
+void room_unexist(ROOM_DATA *room) {
+  // add contents
+  if(listSize(roomGetContents(room)) > 0) {
+    LIST_ITERATOR *cont_i = newListIterator(roomGetContents(room));
+    OBJ_DATA        *cont = NULL;
+    ITERATE_LIST(cont, cont_i)
+      obj_unexist(cont);
+    deleteListIterator(cont_i);
+  }
+
+  // add its people
+  if(listSize(roomGetCharacters(room)) > 0) {
+    LIST_ITERATOR *ch_i = newListIterator(roomGetCharacters(room));
+    CHAR_DATA       *ch = NULL;
+    ITERATE_LIST(ch, ch_i)
+      char_unexist(ch);
+    deleteListIterator(ch_i);
+  }
+
+  // add its exits
+  LIST       *ex_list = roomGetExitNames(room);
+  LIST_ITERATOR *ex_i = newListIterator(ex_list);
+  char           *dir = NULL;
+  ITERATE_LIST(dir, ex_i) {
+    exit_unexist(roomGetExit(room, dir));
+  } deleteListIterator(ex_i);
+  deleteListWith(ex_list, free);
+
+  propertyTableRemove(room_table, roomGetUID(room));
+}
+
 bool room_exists(ROOM_DATA *room) {
   return propertyTableIn(room_table, roomGetUID(room));
 }
@@ -188,6 +236,31 @@
   deleteList(eq);
 }
 
+void char_unexist(CHAR_DATA *ch) {
+  // also unexist inventory
+  if(listSize(charGetInventory(ch)) > 0) {
+    LIST_ITERATOR *inv_i = newListIterator(charGetInventory(ch));
+    OBJ_DATA *obj = NULL;
+    ITERATE_LIST(obj, inv_i)
+      obj_unexist(obj);
+    deleteListIterator(inv_i);
+  }
+
+  // and equipped items
+  LIST *eq = bodyGetAllEq(charGetBody(ch));
+  if(listSize(eq) > 0) {
+    LIST_ITERATOR *eq_i = newListIterator(eq);
+    OBJ_DATA *obj = NULL;
+    ITERATE_LIST(obj, eq_i)
+      obj_unexist(obj);
+    deleteListIterator(eq_i);
+  }
+  deleteList(eq);
+
+  // take us out of the lookup table
+  propertyTableRemove(mob_table, charGetUID(ch));
+}
+
 bool char_exists(CHAR_DATA *ch) {
   return propertyTableIn(mob_table, charGetUID(ch));
 }
@@ -278,7 +351,7 @@
 }
 
 void char_from_game(CHAR_DATA *ch) {
-  // go through all of our fromgame hooks
+  // go through all of our fromgame hooks, then remove us from the mobile list
   hookRun("char_from_game", hookBuildInfo("ch", ch));
 
   // also remove inventory
diff -ruN versions/nakedmudv3.6/src/handler.h src/handler.h
--- versions/nakedmudv3.6/src/handler.h	2008-05-31 00:17:59.000000000 -0400
+++ src/handler.h	2008-12-03 15:19:26.000000000 -0500
@@ -17,22 +17,28 @@
 // called AND THEN it should be added to the game (e.g. loading a character and
 // putting him into a room... call char_to_game first); exist functions are to
 // state that something is ready for interaction with but it is *not* ready to
-// be placed in the game yet. For instance, when a brand new character has been
-// made for character creation. Whenever something is put to_game, it is first
-// make to exist.
+// be placed in the game yet. Conversely, unexist functions are to state that
+// something is no longer ready for interaction but was never part of the game
+// For instance, when a brand new character has been made for character 
+// creation. Whenever something is put to_game, it is first make to exist.
+// Whenever something is remove from_game, it is also immediately unexisted.
 void      char_exist        (CHAR_DATA *ch);
+void      char_unexist      (CHAR_DATA *ch);
 bool      char_exists       (CHAR_DATA *ch);
 void      char_to_game      (CHAR_DATA *ch);
 void      char_from_game    (CHAR_DATA *ch);
 void      obj_exist         (OBJ_DATA  *obj);
+void      obj_unexist       (OBJ_DATA  *obj);
 bool      obj_exists        (OBJ_DATA  *obj);
 void      obj_to_game       (OBJ_DATA  *obj);
 void      obj_from_game     (OBJ_DATA  *obj);
 void      room_exist        (ROOM_DATA *room);
+void      room_unexist      (ROOM_DATA *room);
 bool      room_exists       (ROOM_DATA *room);
 void      room_to_game      (ROOM_DATA *room);
 void      room_from_game    (ROOM_DATA *room);
 void      exit_exist        (EXIT_DATA *exit);
+void      exit_unexist      (EXIT_DATA *exit);
 bool      exit_exists       (EXIT_DATA *exit);
 void      exit_to_game      (EXIT_DATA *exit);
 void      exit_from_game    (EXIT_DATA *exit);
diff -ruN versions/nakedmudv3.6/src/inform.c src/inform.c
--- versions/nakedmudv3.6/src/inform.c	2008-05-31 00:17:59.000000000 -0400
+++ src/inform.c	2008-12-03 02:29:57.000000000 -0500
@@ -304,7 +304,7 @@
     static char buf[MAX_BUFFER];
     va_list args;
     va_start(args, format);
-    vsprintf(buf, format, args);
+    vsnprintf(buf, MAX_BUFFER, format, args);
     va_end(args);
 
     // send it out to everyone
@@ -340,9 +340,10 @@
     static char buf[MAX_BUFFER];
     va_list args;
     va_start(args, format);
-    vsprintf(buf, format, args);
+    vsnprintf(buf, MAX_BUFFER, format, args);
     va_end(args);
     text_to_char(ch, buf);
+    hookRun("char_receive_text", hookBuildInfo("ch str", ch, buf));
     return;
   }
 }
@@ -352,7 +353,7 @@
   static char buf[MAX_BUFFER];
   va_list args;
   va_start(args, format);
-  vsprintf(buf, format, args);
+  vsnprintf(buf, MAX_BUFFER, format, args);
   va_end(args);
 
   LIST_ITERATOR *room_i = newListIterator(roomGetCharacters(charGetRoom(ch)));
@@ -374,7 +375,7 @@
   static char buf[MAX_BUFFER];
   va_list args;
   va_start(args, format);
-  vsprintf(buf, format, args);
+  vsnprintf(buf, MAX_BUFFER, format, args);
   va_end(args);
 
   LIST_ITERATOR *ch_i = newListIterator(mobile_list);
@@ -394,7 +395,7 @@
     static char buf[MAX_BUFFER];
     va_list args;
     va_start(args, format);
-    vsprintf(buf, format, args);
+    vsnprintf(buf, MAX_BUFFER, format, args);
     va_end(args);
 
     // send it out to everyone
@@ -691,7 +692,7 @@
     static char buf[MAX_BUFFER];
     va_list args;
     va_start(args, fmt);
-    vsprintf(buf, fmt, args);
+    vsnprintf(buf, MAX_BUFFER, fmt, args);
     va_end(args);
     message(ch, vict, obj, vobj, hide_nosee, range, buf);
   }
diff -ruN versions/nakedmudv3.6/src/io.c src/io.c
--- versions/nakedmudv3.6/src/io.c	2008-05-31 00:17:59.000000000 -0400
+++ src/io.c	2008-12-01 22:31:26.000000000 -0500
@@ -32,11 +32,11 @@
   va_list args;
 
   va_start(args, txt);
-  vsprintf(buf, txt, args);
+  vsnprintf(buf, MAX_BUFFER, txt, args);
   va_end(args);
 
   /* point to the correct logfile */
-  sprintf(logfile, "../log/%6.6s.log", strtime);
+  snprintf(logfile, MAX_BUFFER, "../log/%6.6s.log", strtime);
 
   /* try to open logfile */
   if ((fp = fopen(logfile, "a")) == NULL)
@@ -65,7 +65,7 @@
   char *strtime = get_time();
 
   va_start(args, txt);
-  vsprintf(buf, txt, args);
+  vsnprintf(buf, MAX_BUFFER, txt, args);
   va_end(args);
 
   /* try to open logfile */
diff -ruN versions/nakedmudv3.6/src/items/container.c src/items/container.c
--- versions/nakedmudv3.6/src/items/container.c	2008-05-31 00:17:59.000000000 -0400
+++ src/items/container.c	2008-12-03 04:15:08.000000000 -0500
@@ -457,33 +457,6 @@
   return 0;
 }
 
-void container_from_proto(CONTAINER_DATA *data, BUFFER *buf) {
-  char line[MAX_BUFFER];
-  const char *code = bufferString(buf);
-  do {
-    code = strcpyto(line, code, '\n');
-    char *lptr = line;
-    if(!strncasecmp(lptr, "me.container_capacity", 21)) {
-      while(*lptr && !isdigit(*lptr)) lptr++;
-      data->capacity = atoi(lptr);
-    }
-    else if(!strncasecmp(lptr, "me.container_key", 16)) {
-      while(*lptr && *lptr != '\"') lptr++;
-      lptr++; // skip leading "
-      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill ending "
-      if(data->key) free(data->key);
-      data->key = strdupsafe(lptr);
-    }
-    else if(!strncasecmp(lptr, "me.container_pick_diff", 22)) {
-      while(*lptr && !isdigit(*lptr)) lptr++;
-      data->pick_diff = atoi(lptr);
-    }
-    else if(!strcasecmp(lptr, "me.container_is_closable = True"))
-      data->closable = TRUE;
-    else; // ignore line
-  } while(*code != '\0');
-}
-
 void container_to_proto(CONTAINER_DATA *data, BUFFER *buf) {
   if(data->capacity > 0)
     bprintf(buf, "me.container_capacity    = %1.3lf\n", data->capacity);
@@ -549,7 +522,7 @@
 
   // set up the container OLC too
   item_add_olc("container", iedit_container_menu, iedit_container_chooser, 
-  	       iedit_container_parser, container_from_proto,container_to_proto);
+  	       iedit_container_parser, NULL, container_to_proto);
   PyObj_addGetSetter("container_capacity",
 		     PyObj_getcontainercapacity, PyObj_setcontainercapacity,
 		     "Sets the maximum amount of weight the container holds.");
diff -ruN versions/nakedmudv3.6/src/items/furniture.c src/items/furniture.c
--- versions/nakedmudv3.6/src/items/furniture.c	2008-05-31 00:17:59.000000000 -0400
+++ src/items/furniture.c	2008-12-03 04:15:37.000000000 -0500
@@ -168,24 +168,6 @@
   }
 }
 
-void furniture_from_proto(FURNITURE_DATA *data, BUFFER *buf) {
-  const char *code = bufferString(buf);
-  char line[SMALL_BUFFER];
-  char *lptr = line;
-  int capacity = 0;
-
-  // two lines: capacity and type. First capacity, then type
-  code = strcpyto(line, code, '\n');
-  sscanf(line, "me.furniture_capacity = %d", &capacity);
-  data->capacity = capacity;
-
-  code = strcpyto(line, code , '\n');
-  while(*lptr && *lptr != '\"') lptr++;
-  lptr++; // skip the leading "
-  lptr[next_letter_in(lptr, '\"')] = '\0'; // kill closing "
-  data->type = furnitureTypeGetNum(lptr);
-}
-
 void furniture_to_proto(FURNITURE_DATA *data, BUFFER *buf) {
   bprintf(buf, "me.furniture_capacity = %d\n",   data->capacity);
   bprintf(buf, "me.furniture_type     = \"%s\"\n", 
@@ -326,7 +308,7 @@
 
   // set up the furniture OLC too
   item_add_olc("furniture", iedit_furniture_menu, iedit_furniture_chooser, 
-  	       iedit_furniture_parser, furniture_from_proto,furniture_to_proto);
+  	       iedit_furniture_parser, NULL, furniture_to_proto);
 
   // add our getters and setters for furniture
   PyObj_addGetSetter("furniture_capacity", 
diff -ruN versions/nakedmudv3.6/src/items/iedit.c src/items/iedit.c
--- versions/nakedmudv3.6/src/items/iedit.c	2008-05-31 00:17:59.000000000 -0400
+++ src/items/iedit.c	2008-12-03 20:14:40.000000000 -0500
@@ -21,13 +21,21 @@
 #include "items.h"
 #include "iedit.h"
 
+
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../scripts/scripts.h"
 #include "../olc2/olc.h"
+#include "../olc2/olc_extender.h"
 
 
 
 //*****************************************************************************
 // local functions, variables, and datastructures
 //*****************************************************************************
+
 // used to store the different sub-olc functions for different item types
 HASHTABLE *item_olc_table = NULL;
 
@@ -35,13 +43,13 @@
   void       (* menu)(SOCKET_DATA *sock, void *data);
   int     (* chooser)(SOCKET_DATA *sock, void *data, const char *option);
   bool     (* parser)(SOCKET_DATA *sock, void *data,int choice,const char *arg);
-  void (* from_proto)(void *data, BUFFER *buf);
+  void (* from_proto)(void *data);
   void   (* to_proto)(void *data, BUFFER *buf);
 } ITEM_OLC_DATA;
 
 ITEM_OLC_DATA *newItemOLC(void *menu, void *chooser, void *parser, 
 			  void *from_proto, void *to_proto) {
-  ITEM_OLC_DATA *data = malloc(sizeof(ITEM_OLC_DATA));
+  ITEM_OLC_DATA *data = calloc(1, sizeof(ITEM_OLC_DATA));
   data->menu       = menu;
   data->chooser    = chooser;
   data->parser     = parser;
@@ -136,20 +144,63 @@
   }
 }
 
-void (* item_from_proto_func(const char *type))(void *data, BUFFER *buf) {
+void item_from_proto(const char *type, void *data) {
   ITEM_OLC_DATA *funcs = hashGet(item_olc_table, type);
-  if(funcs == NULL)
-    return NULL;
-  else
-    return funcs->from_proto;
+  if(funcs != NULL && funcs->from_proto != NULL)
+    funcs->from_proto(data);
 }
 
-void (* item_to_proto_func(const char *type))(void *data, BUFFER *buf) {
+void item_to_proto(const char *type, void *data, BUFFER *buf) {
   ITEM_OLC_DATA *funcs = hashGet(item_olc_table, type);
-  if(funcs == NULL)
-    return NULL;
-  else
-    return funcs->to_proto;
+  if(funcs != NULL && funcs->to_proto != NULL)
+    return funcs->to_proto(data, buf);
+}
+
+
+
+//*****************************************************************************
+// functions for extending oedit
+//*****************************************************************************
+void oedit_item_menu(SOCKET_DATA *sock, OBJ_DATA *obj) {
+  send_to_socket(sock, "Edit item types: {c%s\r\n", objGetTypes(obj));
+}
+
+int oedit_item_choose(SOCKET_DATA *sock, OBJ_DATA *obj) {
+  do_olc(sock, iedit_menu, iedit_chooser, iedit_parser, NULL, NULL, NULL,
+	 NULL, obj);
+  return MENU_NOCHOICE;
+}
+
+void oedit_item_to_proto(OBJ_DATA *obj, BUFFER *buf) {
+  // item types
+  LIST      *item_types = itemTypeList();
+  LIST_ITERATOR *type_i = newListIterator(item_types);
+  char            *type = NULL;
+
+  ITERATE_LIST(type, type_i) {
+    if(objIsType(obj, type)) {
+      void *data = objGetTypeData(obj, type);
+      bprintf(buf, "\n### item type: %s\n", type);
+      bprintf(buf, "me.settype(\"%s\")\n", type);
+      item_to_proto(type, data, buf);
+      //item_to_proto_func(type)(data, buf);      
+      bprintf(buf, "### end type\n");
+    }
+  } deleteListIterator(type_i);
+  deleteListWith(item_types, free);
+}
+
+void oedit_item_from_proto(OBJ_DATA *obj) {
+  // item types
+  LIST      *item_types = itemTypeList();
+  LIST_ITERATOR *type_i = newListIterator(item_types);
+  char            *type = NULL;
+
+  ITERATE_LIST(type, type_i) {
+    if(objIsType(obj, type))
+      item_from_proto(type, obj);
+  } deleteListIterator(type_i);
+  deleteListWith(item_types, free);
 }
 
 
@@ -159,4 +210,9 @@
 //*****************************************************************************
 void init_item_olc() {
   item_olc_table = newHashtable();
+
+  // add our OLC extension
+  extenderRegisterOpt(oedit_extend, 'I', 
+		      oedit_item_menu, oedit_item_choose, NULL, 
+		      oedit_item_from_proto, oedit_item_to_proto);
 }
diff -ruN versions/nakedmudv3.6/src/items/iedit.h src/items/iedit.h
--- versions/nakedmudv3.6/src/items/iedit.h	2008-05-31 00:17:59.000000000 -0400
+++ src/items/iedit.h	2008-12-03 20:14:48.000000000 -0500
@@ -27,10 +27,9 @@
 // (without actually running the script). If we want to have a non-scripting
 // interface for builders, we have to be able to do this. It's pretty simple.
 // For examples on how to go about doing this, see portal.c, container.c, and
-// worn.c. from_proto should take in the data for an item type and a buffer of
-// code relevant to that item type. It should then set values for the item type
-// data, based on the code. It should be of the form:
-//   void from_proto(type *item_type_data, BUFFER *script)
+// worn.c. from_proto should clean up any erroneous stuff that might happen
+// to strings after an object has been parsed into an OLC-editable state.
+//   void from_proto(type *item_type_data)
 // to_proto should do the reverse: given type data, append it to a buffer that
 // is an object prototype (python script). It should also be of the form:
 //   void to_proto(type *item_type_data, BUFFER *script)
@@ -43,7 +42,4 @@
 int  iedit_chooser(SOCKET_DATA *sock, OBJ_DATA *obj, const char *option);
 bool iedit_parser(SOCKET_DATA *sock, OBJ_DATA *obj,int choice, const char *arg);
 
-void (* item_from_proto_func(const char *type))(void *data, BUFFER *buf);
-void   (* item_to_proto_func(const char *type))(void *data, BUFFER *buf);
-
 #endif // IEDIT_H
diff -ruN versions/nakedmudv3.6/src/items/items.c src/items/items.c
--- versions/nakedmudv3.6/src/items/items.c	2008-05-31 00:17:59.000000000 -0400
+++ src/items/items.c	2008-12-03 22:35:12.000000000 -0500
@@ -25,41 +25,143 @@
 
 
 //*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../scripts/scripts.h"
+#include "../scripts/pymudsys.h"
+#include "../scripts/pystorage.h"
+#include "../scripts/pyobj.h"
+#include "../scripts/pyplugs.h"
+
+
+
+//*****************************************************************************
 // local functions, datastructures, and defines
 //*****************************************************************************
 // a table of all our item types, and their assocciated new/delete/etc.. funcs
 HASHTABLE *type_table = NULL;
 
+#define ITYPE_C   0
+#define ITYPE_PY  1
+
 //
 // this is what will go into our type_data table
 typedef struct item_func_data {
-  void          *(* new)();
+  // what type of item function data do we have?
+  int              type;
+
+  // C functions
+  void          *(* new)(void);
   void        (* delete)(void *data);
   void         *(* copy)(void *data);
   void        (* copyto)(void *from, void *to);
   STORAGE_SET *(* store)(void *data);
   void         *(* read)(STORAGE_SET *set);
+
+  // Python functions
+  PyObject *pyfuncs;
+
 } ITEM_FUNC_DATA;
 
+void *ifunc_new(ITEM_FUNC_DATA *funcs) {
+  if(funcs->type == ITYPE_PY) {
+    PyObject *ret = PyInstance_New(funcs->pyfuncs, NULL, NULL);
+    if(ret == NULL)
+      log_pyerr("Error creating new Python item type");
+    return ret;
+  }
+  return funcs->new();
+}
+
+void ifunc_delete(ITEM_FUNC_DATA *funcs, void *data) {
+  if(funcs->type == ITYPE_PY) {
+    Py_XDECREF((PyObject *)data);
+  }
+  else 
+    funcs->delete(data);
+}
+
+void *ifunc_copy(ITEM_FUNC_DATA *funcs, void *data) {
+  if(funcs->type == ITYPE_PY) {
+    PyObject *ret = PyObject_CallMethod(data, "copy", NULL);
+    if(ret == NULL)
+      log_pyerr("Error copying Python item type");
+    return ret;
+  }
+  return funcs->copy(data);
+}
+
+void ifunc_copyto(ITEM_FUNC_DATA *funcs, void *from, void *to) {
+  if(funcs->type == ITYPE_PY) {
+    PyObject *ret = PyObject_CallMethod(from, "copyTo", "O", to);
+    if(ret == NULL)
+      log_pyerr("Error calling copyTo Python item type method");
+    Py_XDECREF(ret);
+  }
+  else
+    funcs->copyto(from, to);
+}
+
+STORAGE_SET *ifunc_store(ITEM_FUNC_DATA *funcs, void *data) {
+  if(funcs->type == ITYPE_PY) {
+    PyObject  *pyset = PyObject_CallMethod(data, "store", NULL);
+    STORAGE_SET *set = NULL;
+    if(pyset != NULL)
+      set = PyStorageSet_AsSet(pyset);
+    else {
+      set = new_storage_set();
+      log_pyerr("Error storing Python item type");
+    }
+
+    Py_XDECREF(pyset);
+    return set;
+  }
+  return funcs->store(data);
+}
+
+void *ifunc_read(ITEM_FUNC_DATA *funcs, STORAGE_SET *set) {
+  if(funcs->type == ITYPE_PY) {
+    PyObject *pyset = newPyStorageSet(set);
+    PyObject  *args = Py_BuildValue("(O)", pyset);
+    PyObject   *ret = PyInstance_New(funcs->pyfuncs, args, NULL);
+    if(ret == NULL)
+      log_pyerr("Error reading Python item type");
+    Py_XDECREF(args);
+    Py_XDECREF(pyset);
+    return ret;
+  }
+  return funcs->read(set);
+}
 
 //
 // create a new structure for holding item type functions
 ITEM_FUNC_DATA *newItemFuncData(void *new, void *delete, void *copyTo,
 				void *copy, void *store, void *read) {
-  ITEM_FUNC_DATA *data = malloc(sizeof(ITEM_FUNC_DATA));
+  ITEM_FUNC_DATA *data = calloc(1, sizeof(ITEM_FUNC_DATA));
   data->new    = new;
   data->delete = delete;
   data->copy   = copy;
   data->copyto = copyTo;
   data->store  = store;
   data->read   = read;
+  data->type   = ITYPE_C;
   return data;
 }
 
+//
+// create a new structure for holding Python item type functions
+ITEM_FUNC_DATA *newPyItemFuncData(PyObject *pyfuncs) {
+  ITEM_FUNC_DATA *data = calloc(1, sizeof(ITEM_FUNC_DATA));
+  data->pyfuncs = pyfuncs;
+  data->type    = ITYPE_PY;
+  Py_XINCREF(pyfuncs);
+  return data;
+}
 
 //
 // deletes one structure for holding item type functions
 void deleteItemFuncData(ITEM_FUNC_DATA *data) {
+  Py_XDECREF(data->pyfuncs);
   free(data);
 }
 
@@ -76,7 +178,7 @@
     // delete the contents of our hashtable
     ITERATE_HASH(key, val, hash_i) {
       ITEM_FUNC_DATA *funcs = hashGet(type_table, key);
-      funcs->delete(hashRemove(table, key));
+      ifunc_delete(funcs, hashRemove(table, key));
     }
     deleteHashIterator(hash_i);
   }
@@ -95,7 +197,7 @@
     // copy all the contents
     ITERATE_HASH(key, val, hash_i) {
       ITEM_FUNC_DATA *funcs = hashGet(type_table, key);
-      hashPut(to, key, funcs->copy(val));
+      hashPut(to, key, ifunc_copy(funcs, val));
     }
     deleteHashIterator(hash_i);
   }
@@ -156,7 +258,7 @@
       STORAGE_SET *one_set = new_storage_set();
       funcs = hashGet(type_table, key);
       store_string(one_set, "type", key);
-      store_set(one_set, "data", funcs->store(val));
+      store_set(one_set, "data", ifunc_store(funcs, val));
       storage_list_put(list, one_set);
     }
     deleteHashIterator(hash_i);
@@ -180,7 +282,7 @@
     if((funcs = hashGet(type_table, type)) == NULL) 
       continue;
     STORAGE_SET *type_set = read_set(one_entry, "data");
-    hashPut(data->item_table, type, funcs->read(type_set));
+    hashPut(data->item_table, type, ifunc_read(funcs, type_set));
   }
   return data;
 }
@@ -188,6 +290,111 @@
 
 
 //*****************************************************************************
+// Python implementation
+//*****************************************************************************
+void item_add_pytype(const char *type, PyObject *pyfuncs) {
+  ITEM_FUNC_DATA *funcs = NULL;
+  // first, make sure no item type by this name already
+  // exists. If one does, delete it so it can be replaced
+  if((funcs = hashRemove(type_table, type)) != NULL)
+    deleteItemFuncData(funcs);
+  funcs = newPyItemFuncData(pyfuncs);
+  hashPut(type_table, type, funcs);
+}
+
+PyObject *PyMudSys_ItemAddType(PyObject *self, PyObject *args) {
+  char        *type = NULL;
+  PyObject *pyclass = NULL;
+
+  // parse out our socket and functions
+  if(!PyArg_ParseTuple(args, "sO",&type, &pyclass)) {
+    PyErr_Format(PyExc_TypeError,"Invalid arguments supplied to " 
+		 "item_add_type");
+    return NULL;
+  }
+
+  // make sure it has a string that says what item type it is
+  if(!PyObject_HasAttrString(pyclass, "__item_type__") ||
+     !PyString_Check(PyObject_GetAttrString(pyclass, "__item_type__"))) {
+    PyErr_Format(PyExc_TypeError,"Python item types must have an attribute, "
+		 "__item_type__, that describes what type of item data it is.");
+    return NULL;
+  }
+
+  // check to make sure it has all of the relevant methods
+  //***********
+  // FINISH ME
+  //***********
+
+  // create the new type
+  item_add_pytype(type, pyclass);
+  return Py_BuildValue("i", 1);
+}
+
+PyObject *PyObj_GetTypeData(PyObject *self, PyObject *args) {
+  OBJ_DATA         *obj = PyObj_AsObj(self);
+  ITEM_FUNC_DATA *fdata = NULL;
+  char            *type = NULL;
+
+  if(!PyArg_ParseTuple(args, "s", &type)) {
+    PyErr_Format(PyExc_TypeError, "get_type_data must be supplied a string.");
+    return NULL;
+  }
+
+  // make sure it's Python data
+  fdata = hashGet(type_table, type);
+  if(fdata == NULL || fdata->type == ITYPE_C)
+    return Py_BuildValue("O", Py_None);
+  return Py_BuildValue("O", objGetTypeData(obj, type));
+}
+
+PyObject *PyObj_istype(PyObject *self, PyObject *args) {  
+  char *type = NULL;
+
+  // make sure we're getting passed the right type of data
+  if (!PyArg_ParseTuple(args, "s", &type)) {
+    PyErr_Format(PyExc_TypeError, "istype only accepts strings.");
+    return NULL;
+  }
+
+  // pull out the object and check the type
+  OBJ_DATA    *obj = PyObj_AsObj((PyObject *)self);
+  if(obj != NULL)
+    return Py_BuildValue("i", objIsType(obj, type));
+  else {
+    PyErr_Format(PyExc_StandardError, 
+		 "Tried to check type of nonexistent object, %d.", 
+		 PyObj_AsUid(self));
+    return NULL;
+  }
+}
+
+PyObject *PyObj_settype(PyObject *self, PyObject *args) {  
+  char *type = NULL;
+
+  // make sure we're getting passed the right type of data
+  if (!PyArg_ParseTuple(args, "s", &type)) {
+    PyErr_Format(PyExc_TypeError, "settype only accepts strings.");
+    return NULL;
+  }
+
+  // pull out the object and check the type
+  OBJ_DATA    *obj = PyObj_AsObj((PyObject *)self);
+  if(obj != NULL) {
+    objSetType(obj, type);
+    return Py_BuildValue("i", 1);
+  }
+  else {
+    PyErr_Format(PyExc_StandardError, 
+		 "Tried to set type of nonexistent object, %d.", 
+		 PyObj_AsUid(self));
+    return NULL;
+  }
+}
+
+
+
+//*****************************************************************************
 // implementation of items.h
 //*****************************************************************************
 void init_items(void) {
@@ -198,6 +405,22 @@
 				       itemDataCopy, itemDataStore, 
 				       itemDataRead));
 
+  // initialize Python mudsys methods
+  PyMudSys_addMethod("item_add_type", PyMudSys_ItemAddType, METH_VARARGS,
+		     "add a new type of item to the game");
+
+  // initialize Python pyobj methods
+  PyObj_addMethod("get_type_data", PyObj_GetTypeData, METH_VARARGS,
+		  "Returns the Python data associated with the item type.");
+  PyObj_addMethod("istype", PyObj_istype, METH_VARARGS,
+		  "checks to see if the object is of the specified type");
+  PyObj_addMethod("settype", PyObj_settype, METH_VARARGS,
+		  "the object will become of the specified type");
+  // do we need a deltype as well?
+  //***********
+  // FINISH ME
+  //***********
+
   // initialize item olc
   init_item_olc();
 
@@ -243,14 +466,14 @@
   void   *old_item_data = hashGet(data->item_table, type);
   // if the type exists and we're not already of the type, set it on us
   if(funcs != NULL && old_item_data == NULL) 
-    hashPut(data->item_table, type, funcs->new());
+    hashPut(data->item_table, type, ifunc_new(funcs));
 }
 
 void objDeleteType(OBJ_DATA *obj, const char *type) {
   ITEM_FUNC_DATA *funcs = hashGet(type_table, type);
   ITEM_DATA *data       = objGetAuxiliaryData(obj, "type_data");
   void *old_item_data   = hashRemove(data->item_table, type);
-  if(old_item_data) funcs->delete(old_item_data);
+  if(old_item_data) ifunc_delete(funcs, old_item_data);
 }
 
 bool objIsType(OBJ_DATA *obj, const char *type) {
